# Generated by Django 2.1.7 on 2019-03-07 09:14

import django.contrib.postgres.fields.jsonb
from django.db import migrations


migration_fields = (
        ('puzzle', 'runtime', 'options'),
        ('puzzle', 'cb_runtime', 'cb_options'),
        ('puzzle', 'soln_runtime', 'soln_options'),
        ('answer', 'runtime', 'options'),
        ('unlockanswer', 'runtime', 'options'),
)


class Migration(migrations.Migration):

    dependencies = [
        ('hunts', '0002_auto_20190305_0948'),
    ]

    operations = [
        migrations.AddField(
            model_name='answer',
            name='options',
            field=django.contrib.postgres.fields.jsonb.JSONField(blank=True, default=dict, help_text="Options for configuring the validator in JSON format using the following keys:\n\nStatic:\n    'case_handling':\n        'none' - do not adjust case\n        'lower' - compare lower case\n        'fold' - perform unicode case folding\n    'strip': true/false\n\nRegex:\n    'case_sensitive': true/false", verbose_name='Validator configuration'),
        ),
        migrations.AddField(
            model_name='puzzle',
            name='cb_options',
            field=django.contrib.postgres.fields.jsonb.JSONField(blank=True, default=dict, help_text='Options for configuring the AJAX callback processor in JSON format. Currently no options are supported.', verbose_name='AJAX callback processor configuration'),
        ),
        migrations.AddField(
            model_name='puzzle',
            name='options',
            field=django.contrib.postgres.fields.jsonb.JSONField(blank=True, default=dict, help_text='Options for configuring the puzzle page renderer in JSON format. Currently no options are supported.', verbose_name='Puzzle page renderer configuration'),
        ),
        migrations.AddField(
            model_name='puzzle',
            name='soln_options',
            field=django.contrib.postgres.fields.jsonb.JSONField(blank=True, default=dict, help_text='Options for configuring the solution renderer in JSON format. Currently no options are supported.', verbose_name='Solution renderer configuration'),
        ),
        migrations.AddField(
            model_name='unlockanswer',
            name='options',
            field=django.contrib.postgres.fields.jsonb.JSONField(blank=True, default=dict, help_text="Options for configuring the validator in JSON format using the following keys:\n\nStatic:\n    'case_handling':\n        'none' - do not adjust case\n        'lower' - compare lower case\n        'fold' - perform unicode case folding\n    'strip': true/false\n\nRegex:\n    'case_sensitive': true/false", verbose_name='Validator configuration'),
        ),
        migrations.RunSQL(
            sql=[
                f"UPDATE hunts_{table} SET {options_field}='{{\"case_handling\": \"none\"}}' WHERE {runtime_field}='S'"
                for table, runtime_field, options_field in migration_fields
            ] + [
                f"UPDATE hunts_{table} SET {runtime_field}='S', {options_field}='{{\"case_handling\": \"lower\"}}' WHERE {runtime_field}='s'"
                for table, runtime_field, options_field in migration_fields
            ] + [
                f"UPDATE hunts_{table} SET {options_field}='{{\"case_sensitive\": false}}' WHERE {runtime_field}='R'"
                for table, runtime_field, options_field in migration_fields
            ] + [
                f"UPDATE hunts_{table} SET {runtime_field}='R', {options_field}='{{\"case_sensitive\": true}}' WHERE {runtime_field}='r'"
                for table, runtime_field, options_field in migration_fields
            ],
            reverse_sql=[
                f"UPDATE hunts_{table} SET {runtime_field}='s' WHERE {runtime_field}='S' AND {options_field} ->> 'case_handling' = 'lower'"
                for table, runtime_field, options_field in migration_fields
            ] + [
                f"UPDATE hunts_{table} SET {runtime_field}='r' WHERE {runtime_field}='R' AND CAST({options_field} ->> 'case_sensitive' AS BOOLEAN) = true"
                for table, runtime_field, options_field in migration_fields
            ],
            elidable=True,
        ),
    ]
